-- Pin by Jadya
-- EU - Well of Eternity
local addonName, addonTable = ...
local L = addonTable.L

local groups = addonTable.GroupFunctions
local notes = addonTable.NoteFunctions

--[[

 - group -
 
 .id								id
 .name								name
 .notes 							ids array
-- custom visibility
 .visibility_class_<classname> 		bool
 
]]

local function getNewID(t)
 local result = (PinSaves.gID or 0) + 1
 PinSaves.gID = result
 return result
end

function groups:New()
 local g = PinSaves.groups

 local id = getNewID()
 local group = {}
 group.id    = id
 group.name  = L["new_group"]
 group.notes = {}
 group.visibility = 0

 g[id] = group

 return group
end

function groups:Delete(group)
 for k,v in pairs(group.notes) do
  notes:Delete(addonTable.notes[v])
 end

 PinSaves.groups[group.id] = nil
end

function groups:IsActive(group)
 -- custom visibility 
 if group.visibility == 2 then
  return group["visibility_char_"..addonTable.playername] or group["visibility_class_"..addonTable.playerclass]
 else
  return group.visibility == 0
 end
end

function groups:Show(group)
 if not group then return end
 
 for k,v in pairs(group.notes) do
  if not addonTable.notes[v] then
   notes:Load(v)
  else
   addonTable.notes[v]:Show()
  end
 end
end

function groups:Hide(group)
 for k,v in pairs(group.notes) do
  if addonTable.notes[v] then
   addonTable.notes[v]:Hide()
  end
 end
end

function groups:HideAll()
 for k,v in pairs(PinSaves.groups) do
  groups:Hide(v)
 end
end

function groups:Load(group, forced)
 if forced or groups:IsActive(group) then
  groups:Show(group)
 end
end

function groups:ShowActive()
 groups:HideAll()
 for k,v in pairs(PinSaves.groups) do
  if groups:IsActive(v) then
   groups:Show(v)
  end
 end
end